/*
 *  Copyright 2009 Tsutomu YANO.
 * 
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 * 
 *       http://www.apache.org/licenses/LICENSE-2.0
 * 
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *  under the License.
 */

package jp.gihyo.wicket;

import org.apache.wicket.IRequestTarget;
import org.apache.wicket.request.RequestParameters;
import org.apache.wicket.request.target.coding.AbstractRequestTargetUrlCodingStrategy;
import org.apache.wicket.util.string.AppendingStringBuffer;

/**
 *
 * @author Tsutomu YANO
 */
public class LoginProcessorUrlCodingStrategy extends AbstractRequestTargetUrlCodingStrategy {

    public LoginProcessorUrlCodingStrategy(String mountPath) {
        super(mountPath);
    }

    public CharSequence encode(IRequestTarget requestTarget) {
        if (!(requestTarget instanceof LoginProcessor)) {
                throw new IllegalArgumentException("this encoder can only be used with instances of " +
                        LoginProcessor.class.getName());
        }
        AppendingStringBuffer url = new AppendingStringBuffer(40);
        url.append(getMountPath());
        appendParameters(url, ((LoginProcessor)requestTarget).getParameterMap());
        return url;
    }

    public IRequestTarget decode(RequestParameters requestParameters) {
        return new LoginProcessor(requestParameters);
    }

    public boolean matches(IRequestTarget requestTarget) {
        return requestTarget instanceof LoginProcessor;
    }

}
